import string
import secrets

from mongo.get_conn import db_conn

class pool_query:
    """
    This class will allow us to
    interact with our data to interact
    just create a realestate_data var
    """
    def __init__(self):
        #db_conn has all the the things
        #already created from here 
        #we can get self.db.real_db etc 
        self.db = db_conn()

    def record_exists(self, test_user, date):
        """
            This function will accept an address
            if it find that address in the database it will return True
            and set set the existing_record variable of the class to the 
            queried record
        """
        query = { "test_user" : f"{test_user}", "date" : f"{date}"}
        record = self.db.real_db.find_one(query)
        if record:
            self.existing_record = record
            return True
        else:
            return False

    def get_top(self, num_limit, value_field):
        """
            This function will return the
            last n records of the chosen value field
            It will take the number of records you want to 
            return as a parameter
        """
        records = self.db.pool_db.find({}, {"test_user": 1, "_id": 0, "date": 1, f"{value_field}": 1}).sort("date", -1).limit(num_limit)
        return records

    def user_check(self, username, password):
        """
            function to check username and password
            back in db
        """
        #TODO: this ueses my own quick hack it likley needs to be rewrittent to follow best practice

        query = { "username" : f"{username}", "password" : f"{password}" }
        record = self.db.users.find_one(query)
        if record:
            return True
        else:
            return False
